using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

using Telerik.Web.UI;

using BE;
using BL;
using Utilitaria;


public partial class InstUpd_CanalesContables : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["Usuario"] == null)
        {
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind();", true);
        }

        this.txtNomenclatura.Focus();
        if (!IsPostBack)
        {
            llenaCombo();

            if (ViewState["CanalContableID"] != null) { BuscaRegistro(); } else { this.ddlEstado2.SelectedValue = Utilitaria.Cls_Enums.EstadoModulos.Activo; }
        }

        //ddlTipoFormatoGGPP.Filter = (RadComboBoxFilter)Convert.ToInt32(2);
    }

   
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        if (Request.QueryString["CanalContableID"] == null)
        {
            this.btnGuardar.Text = "  Crear  ";
        }
        else
        {
            this.btnGuardar.Text = "Actualizar";
            ViewState["CanalContableID"] = Request.QueryString["CanalContableID"].ToString().Trim();
        }
    }

    private void llenaCombo()
    {
        //this.ddlEstado.Items.Insert(0, "---Todos---");
        //this.ddlEstado.Items[0].Value = Utilitaria.Cls_Enums.EstadoModulos.Todos;

        //this.ddlEstado2.Items.Insert(0, new RadComboBoxItem("---Seleccione---"));
        //this.ddlEstado2.Items[0].Value = Utilitaria.Cls_Enums.EstadoModulos.Todos;

        this.ddlEstado2.Items.Insert(0, new RadComboBoxItem("Activo"));
        this.ddlEstado2.Items[0].Value = Utilitaria.Cls_Enums.EstadoModulos.Activo;

        this.ddlEstado2.Items.Insert(1, new RadComboBoxItem("Inactivo"));
        this.ddlEstado2.Items[1].Value = Utilitaria.Cls_Enums.EstadoModulos.Inactivo;
    }

    private void BuscaRegistro()
    {
        BECanalesContables objet_CanalesContables = new BECanalesContables();
        BLCanalesContables objlg_CanalesContables = new BLCanalesContables();
        List<BECanalesContables> Datos;

        Datos = objlg_CanalesContables.fnSelCanalesContablesDin("CanalContableID=" + Convert.ToString(ViewState["CanalContableID"]), "");

        ViewState["CanalContableID"] = Datos[0].CanalContableID;

        // Inicio Variables auditoras ///
        ViewState["CodigoCanalContable"] = Datos[0].CodigoCanalContable;
        ViewState["NombreCanalContable"] = Datos[0].NombreCanalContable;
        ViewState["Estado"] = Datos[0].Estado;
        ///////FIN//////////

        this.txtNomenclatura.Text = Convert.ToString(ViewState["CodigoCanalContable"]);
        this.txtNombre.Text = Convert.ToString(ViewState["NombreCanalContable"]);
        this.ddlEstado2.SelectedValue = Convert.ToString(ViewState["Estado"]);

        objet_CanalesContables = null;
        objlg_CanalesContables = null;
        Datos = null;
    }


    private void limpiarCampos()
    {
        ViewState["CanalContableID"] = "";
        this.txtNombre.Text = String.Empty;
        this.txtNomenclatura.Text = String.Empty;
        this.ddlEstado2.SelectedValue = Utilitaria.Cls_Enums.EstadoModulos.Todos;

    }


    protected void btnGuardar_Click(object sender, EventArgs e)
    {

        BECanalesContables objet_CanalesContables = new BECanalesContables();
        BLCanalesContables objlg_CanalesContables = new BLCanalesContables();

        String strCanalContableID = Convert.ToString(ViewState["CanalContableID"]);
        String strRegistro;
        String strActualiza;

        ViewState["New_CodigoCanalContable"] = this.txtNomenclatura.Text;
        ViewState["New_NombreCanalContable"] = this.txtNombre.Text;
        ViewState["New_Estado"] = Convert.ToByte(this.ddlEstado2.SelectedValue);

        objet_CanalesContables.CanalContableID = strCanalContableID;
        objet_CanalesContables.CodigoCanalContable = Convert.ToString(ViewState["New_CodigoCanalContable"]).Trim();
        objet_CanalesContables.NombreCanalContable = Convert.ToString(ViewState["New_NombreCanalContable"]).Trim();
        objet_CanalesContables.Estado = Convert.ToByte(ViewState["New_Estado"]);

        strRegistro = "<<Creo CanalesContables>>" +
                      "\n<CodigoCanalContable>=" + ViewState["New_CodigoCanalContable"] +
                      "\n<NombreCanalContable>=" + ViewState["New_NombreCanalContable"] +
                      "\n<Estado>=" + ViewState["New_Estado"];

        //Ingresa
        objet_CanalesContables.BEAuditores.UsuarioID = Convert.ToInt32(Session["UsuarioID"]);
        objet_CanalesContables.BEAuditores.Movimiento = strRegistro;
        objet_CanalesContables.BEAuditores.UsuarioIdAutorizado = 0;
        objet_CanalesContables.BEAuditores.IPEquipo = Cls_Enums.f_DatosPC.IPPC;
        objet_CanalesContables.BEAuditores.UsuarioActualEquipo = Cls_Enums.f_DatosPC.UsuarioPC;
        objet_CanalesContables.BEAuditores.NombreEquipo = Cls_Enums.f_DatosPC.NombrePC;
        objet_CanalesContables.BEAuditores.TablaMovimientoID = Cls_Enums.TablaMovimientos.CanalesContables;

        if (strCanalContableID != String.Empty)
        {
            //Update
            strRegistro = "<<Actualiza CanalesContables>>" +
                          "\n<CodigoCanalContable>=" + ViewState["CodigoCanalContable"] +
                          "\n<NombreCanalContable>=" + ViewState["NombreCanalContable"] +
                          "\n<Estado>=" + ViewState["Estado"];

            strActualiza = "<<Actualiza CanalesContables>>" +
                           "\n<CodigoCanalContable>=" + ViewState["New_CodigoCanalContable"] +
                           "\n<NombreCanalContable>=" + ViewState["New_NombreCanalContable"] +
                           "\n<Estado>=" + ViewState["New_Estado"];

            objet_CanalesContables.BEAuditores.Movimiento = strRegistro;
            objet_CanalesContables.BEAuditores.MovimientoUltimo = strActualiza;

            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind();", true);
        }
        else {
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind('navigateToInserted');", true);
        }

        Int32 registro = objlg_CanalesContables.fnInsUpdCanalesContables(objet_CanalesContables);

        if (registro == 1) { showMessage("El Codigo del Canal Contable ya esta registrado"); return; };

        objet_CanalesContables = null;
        objlg_CanalesContables = null;
        this.limpiarCampos();
    }


    protected void btnVolver_Click(object sender, EventArgs e)
    {
        ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CancelEdit();", true);
        this.limpiarCampos();
    }

    protected void showMessage(string strMessage)
    {
        ScriptManager.RegisterStartupScript(this, this.GetType(), "myscript", "alert('" + strMessage + "');", true);

    }

    
}
